;**********************************************************************
;				SIGHT.ASM
;**********************************************************************

;DATE: October 28, 2009
;VERSION: B
;XTAL TYPE:  Internal 4 MHZ
;WRITTEN BY: RON NEWTON
;GENERAL REGISTER STARTS @ 07H
;INTERRUPT VECTOR =  NONE
;END OF PROGRAM MEMORY = 03FFH
;COMMENTS:  
;
;
;
;
;**********************************************************
    
    list        p=12F508       	; list directive to define processor
	RADIX		DEC					;YOU CAN CHANGE THIS TO DEC OR OCT DEFAULT IS HEX
    #include    <p12F508.inc>   	; processor specific variable definitions
    
	   __CONFIG  _MCLRE_OFF & _CP_OFF  & _WDT_OFF   & _IntRC_OSC  

; PORT DESCRIPTIONS
; GPIO 4 GROUND LASER DIODE
; ALL GPIOS EXCEPT 1 GO TO GROUND WHEN FIRED.
; PIN 1 VDD 5 VOLTS
; PIN 2 GP5 NC
; PIN 3 GP4 LASER GROUND PULSED
; PIN 4 MCLRE NC
; PIN 5 GP2 NC
; PIN 6 GP1 NC
; PIN 7 GP0 MICROPHONE IN
; PIN 8 VSS GROUND

;NEW REGISTERS
COUNTER		EQU		07H			;COUNTER FOR TIMING
COUNTER1	EQU		08H			;COUNTER 1 FOR TIMING

	ORG		0H						;START OF PROGRAM OR RESET


START
		BTFSC		STATUS,7		;CHECKING TO SEE IF MICROPHONE TRIPPED
		GOTO		S1				;MICROPHONE TRIPPED JUMP TO S1
		MOVLW		255				;MAKE GP0 INPUT
		TRIS		GPIO			;LOAD
		MOVLW		0				;ACTIVATE PULL UP RESISTORS
		OPTION						;LOAD
		BSF			GPIO,4			;TURN OFF LASER	
		BTFSS		GPIO,0			;MAKE SURE MICROPHONE IS HIGH
		GOTO		$-1				;REPEAT
		NOP							;FOR DEBUGGER
		SLEEP						;PUT TO SLEEP
		NOP							;FOR DEBUGGER

S1		MOVLW		B'00101111'		;MAKE GPIO4 OUTPUT
		TRIS		GPIO			;LOAD
		MOVWF		5				;MOVING 5 INTO COUNTER1
		MOVWF		COUNTER1		;MOVE
S2		BCF			GPIO,4			;TURN ON LASER
		DECFSZ		COUNTER,1		;COUNTER BEING DECREASED
		GOTO		S2				;SKIP WHEN ZERO
		DECFSZ		COUNTER1,1		;COUNTER 1 BEING DECREASED
		GOTO		S2				;SKIP WHEN ZERO
		BSF			GPIO,4			;TURN OFF LASER
		MOVLW		0				;RESET OPTION
		OPTION
		BTFSS		GPIO,0			;CHECK FOR GPIO 0 FOR BEING HIGH
		GOTO		$-1				;CONTINUE UNTIL HIGH
		BCF			STATUS,7		;RESET STATUS (MICROPHONE)
		GOTO		START			;RETURN

    END                       		; directive 'end of program'