;**********************************************************************
;				TARGET.ASM
;**********************************************************************


;DATE; 12/16/2009  Revised June 17 2010
;VERSION: 5
;WORKING MODEL
;XTAL TYPE:  INTERNAL 20 MHZ
;WRITTEN BY: RON NEWTON
;GENERAL REGISTER STARTS @ 20h
;INTERRUPT VECTOR = 04h
;END OF PROGRAM MEMORY = 0FFFH
;COMMENTS:  THIS PROGRAM DETECTS A LASER AND DIPLAYS A COUNT AND WHERE THE LASER STRUCK
;BCF DIGITS FOR TURNING ON

;**********************************************************
    
    list        p=16f917        ; list directive to define processor
	RADIX		DEC				;YOU CAN CHANGE THIS TO DEC OR OCT DEFAULT IS HEX
    #include    <p16f917.inc>   ; processor specific variable definitions
    
    __CONFIG (_DEBUG_OFF & _FCMEN_OFF & _IESO_OFF  & _BOD_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_OFF & _WDT_OFF & _INTRC_OSC_NOCLKOUT)

; PORT DESCRIPTIONS
;RA0 COLUMN 7
;RA1 COLUMN 6
;RA2 COLUMN 5
;RA3 COLUMN 4
;RA4 COLUMN 3
;RA5 COLUMN 2
;RA6 COLUMN 1
;RA7 NC
;RB0 NC
;RB1 ROW 1
;RB2 ROW 2
;RB3 ROW 3
;RB4 ROW 4
;RB5 ROW 5
;RB6 ROW 6 
;RB7 ROW 7
;RC0 NC
;RC1 NC
;RC2 NC
;RC3 NC
;RC4 DIGIT 1
;RC5 DIGIT 3
;RC6 DIGIT 2
;RC7 NC
;RD0 DECIMAL
;RD1 B
;RD2 A
;RD3 G
;RD4 D
;RD5 C
;RD6 E
;RD7 F
;RE0 SWITCH
;RE1 SWITCH
;RE2 SWITCH
;RE3 RESET

#DEFINE 	DIGIT_ONE		PORTC,4		;7 SEGMENT DISPLAY
#DEFINE		DIGIT_TWO		PORTC,6		;7 SEGMENT DISPLAY
#DEFINE		DIGIT_THREE		PORTC,5		;7 SEGMENT DISPLAY
#DEFINE		COL7			PORTA,0		;COLUMN CONTROL 
#DEFINE		COL6			PORTA,1		;COLUMN CONTROL
#DEFINE		COL5			PORTA,2		;COLUMN CONTROL
#DEFINE		COL4			PORTA,3		;COLUMN CONTROL
#DEFINE		COL3 			PORTA,4		;COLUMN CONTROL
#DEFINE		COL2			PORTA,5		;COLUMN CONTROL
#DEFINE		COL1			PORTA,6		;COLUMN CONTROL
#DEFINE		ROW1			PORTB,1		;ROW CONTROL
#DEFINE		ROW2			PORTB,2		;ROW CONTROL
#DEFINE		ROW3			PORTB,3		;ROW CONTROL
#DEFINE		ROW4			PORTB,4		;ROW CONTROL
#DEFINE		ROW5			PORTB,5		;ROW CONTROL
#DEFINE		ROW6			PORTB,6		;ROW CONTROL
#DEFINE		ROW7			PORTB,7		;ROW CONTROL
#DEFINE		SWITCH1			PORTE,0		;PROGRAM CONTROL
#DEFINE		SWITCH2			PORTE,1		;PROGRAM CONTROL
#DEFINE		SWITCH3			PORTE,2		;PROGRAM CONTROL

;NEW REGISTERS

TRUE  		EQU     1				;MATH REGISTER			
FALSE 	  	EQU 	0				;MATH REGISTER

ONES		EQU		20H				;DISPLAY REGISTER
TENS		EQU		21H				;DISPLAY REGISTER
HUNDREDS	EQU		22H				;DISPLAY REGISTER
TARGET		EQU		23H				;TARGET COUNT FOR POINTS
COUNT1		EQU		24H				;DELAY COUNTING REGISTER
COUNT2		EQU		25H				;DELAY COUNTING REGISTER
COUNT3		EQU		26H				;DELAY COUNTING REGISTER
COUNT4		EQU		27H				;DELAY COUNTING REGISTER
FLAGS		EQU		28H				;FLAG REGISTER (8 FLAGS AVAILABLE)
MATH_HIGH	EQU		29H				;MATH REGISTER FOR CONVERSION FROM DECIMAL TO BCD
THOUSANDS	EQU		2AH				;MATH REGISTER FOR CONVERSION FROM DECIMAL TO BCD
MATH_LOW	EQU		2BH				;MATH REGISTER FOR CONVERSION FROM DECIMAL TO BCD
TENK		EQU		2CH				;MATH REGISTER FOR CONVERSION FROM DECIMAL TO BCD
TEMP		EQU		2DH				;MATH REGISTER FOR CONVERSION FROM DECIMAL TO BCD
FIRST_ROW	EQU		2EH				;STORAGE REGISTER STORAGE REGISTER USED FOR RAPID FIRE
FIRST_COL	EQU		2FH				;STORAGE REGISTER USED FOR RAPID FIRE
SECOND_ROW	EQU		30H				;STORAGE REGISTER USED FOR RAPID FIRE
SECOND_COL	EQU		31H				;STORAGE REGISTER USED FOR RAPID FIRE
THIRD_ROW	EQU		32H				;STORAGE REGISTER USED FOR RAPID FIRE	
THIRD_COL	EQU		33H				;STORAGE REGISTER USED FOR RAPID FIRE
FOURTH_ROW	EQU		34H				;STORAGE REGISTER USED FOR RAPID FIRE	
FOURTH_COL	EQU		35H				;STORAGE REGISTER USED FOR RAPID FIRE
FIFTH_ROW	EQU		36H				;STORAGE REGISTER USED FOR RAPID FIRE
FIFTH_COL	EQU		37H				;STORAGE REGISTER USED FOR RAPID FIRE
SIXTH_ROW	EQU		38H				;STORAGE REGISTER USED FOR RAPID FIRE
SIXTH_COL	EQU		39H				;STORAGE REGISTER USED FOR RAPID FIRE	
COUNT		EQU		3AH				;STORAGE REGISTER USED FOR RAPID FIRE	
TRISB1		EQU		3BH				;STORAGE REGISTER USED FOR RAPID FIRE
TRISB2		EQU		3CH				;STORAGE REGISTER USED FOR RAPID FIRE
TRISB3		EQU		3DH				;STORAGE REGISTER USED FOR RAPID FIRE
TRISB4		EQU		3EH				;STORAGE REGISTER USED FOR RAPID FIRE
TRISB5		EQU		3FH				;STORAGE REGISTER USED FOR RAPID FIRE
TRISB6		EQU		40H				;STORAGE REGISTER USED FOR RAPID FIRE
TRISA1		EQU		41H				;STORAGE REGISTER USED FOR RAPID FIRE
TRISA2		EQU		42H				;STORAGE REGISTER USED FOR RAPID FIRE
TRISA3		EQU		43H				;STORAGE REGISTER USED FOR RAPID FIRE
TRISA4		EQU		44H				;STORAGE REGISTER USED FOR RAPID FIRE
TRISA5		EQU		45H				;STORAGE REGISTER USED FOR RAPID FIRE
TRISA6		EQU		46H				;STORAGE REGISTER USED FOR RAPID FIRE
COUNT5		EQU		47H				;COUNTING REGISTER FOR TIMING
COUNT6		EQU		48H				;COUNTING REGISTER FOR TIMING


	ORG		0H								;START OF PROGRAM OR RESET
		CLRF		MATH_HIGH				;CLEAR MATH HIGH
		CLRF		MATH_LOW				;CLEAR MATH LOW
		CLRF		TARGET					;CLEAR TARGET
		CLRF		COUNT 					;CLEAR COUNT
		CALL		INTIALIZING				;INTIALIZE MICRO
		DECFSZ		COUNT1,1
		GOTO		$-1
		DECFSZ		COUNT2,1
		GOTO		$-3
		GOTO		START					;JUMP TO START


INTIALIZING									;LABEL
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CLRF		PORTB					;CLEAR PORT B
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		CLRF		TRISB					;MAKE TRISB ALL OUTPUTS
		BANKSEL		PORTC					;MAKE SURE IN RIGHT BANK
		CLRF		PORTC					;CLEAR PORT C
		BANKSEL		TRISC					;MAKE SURE IN RIGHT BANK
		CLRF		TRISC					;MAKE TRISC ALL OUTPUTS
		BANKSEL		PORTD					;MAKE SURE IN RIGHT BANK
		CLRF		PORTD					;CLEAR PORT D
		BANKSEL		TRISD					;MAKE SURE IN RIGHT BANK
		CLRF		TRISD					;MAKE TRISD ALL OUTPUTS
		BANKSEL		PORTE					;MAKE SURE IN RIGHT BANK
		CLRF		PORTE					;CLEAR PORT E
		BANKSEL		TRISE					;MAKE SURE IN RIGHT BANK
		MOVLW		B'1111'					;SET TRIS E FOR PROGRAMING					
		MOVWF		TRISE					;LOAD
		BANKSEL		ANSEL					;MAKE SURE IN RIGHT BANK
		CLRF		ANSEL					;CLEAR PORT ANSEL
		BANKSEL		OPTION_REG				;MAKE SURE IN RIGHT BANK
		CLRF		OPTION_REG				;CLEAR OPTION REGISTER
		BANKSEL		WPUB					;MAKE SURE IN RIGHT BANK
		MOVLW		0						;PORT B PULL RESISTOR
		MOVWF		WPUB					;LOAD
		
		BANKSEL		CMCON0					;MAKE SURE IN RIGHT BANK
		MOVLW		B'00000111'				;TURN COMPARATORS OFF				
		MOVWF		CMCON0					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		CLRF		PORTA					;CLEAR PORT A
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		CLRF		TRISA					;LOADING TRISA	
		BANKSEL		INTCON					;MAKE SURE IN RIGHT BANK
		CLRF		INTCON					;CLEAR INTCON
		BANKSEL		OSCCON					;MAKE SURE IN RIGHT BANK
		MOVLW		B'01110000'				;LOADING OSCCON
		MOVWF		OSCCON					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		255						;MAKE PORT D ALL ONES
		MOVWF		PORTD					;LOAD
		CLRF		PORTA					;CLEAR PORT A
		RETURN								;RETURN WHEN CALLED

;***************************STARTING*****************************

START										;LABEL
		BCF			PORTD,3					;DISPLAY BAR DIGIT 2
		BSF			PORTC,4					;DISPLAY BAR DIGIT 2
		BSF			PORTC,5					;DISPLAY BAR DIGIT 2
		BCF			PORTC,6					;DISPLAY BAR DIGIT 2

A0											;LABEL
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		CLRF		TRISB					;MAKE TRISB ALL ZEROS
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVLW		255						;MAKE PORT B ALL ONES
		MOVWF		PORTB
		BTFSS		ROW1					;INSURE ROW 1 IS HIGH
		GOTO		$-1
		BTFSS		ROW2					;INSURE ROW 2 IS HIGH
		GOTO		$-1
		BTFSS		ROW3					;INSURE ROW 3 IS HIGH
		GOTO		$-1
		BTFSS		ROW4					;INSURE ROW 4 IS HIGH
		GOTO		$-1
		BTFSS		ROW5					;INSURE ROW 5 IS HIGH
		GOTO		$-1
		BTFSS		ROW6					;INSURE ROW 6 IS HIGH
		GOTO		$-1
		BTFSS		ROW7					;INSURE ROW 7 IS HIGH
		GOTO		$-1

;*************************COLUMN 1 ************************************



C1R1   										;LABEL
	    BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'10111111'				;GROUND COLUMN ONE
		MOVWF		PORTA					;LOAD
		MOVLW		255						;MAKE PORT B HIGH
		MOVWF		PORTB					;LOAD
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'10111111'				;LOADING TRISA
		MOVWF		TRISA					;COLUMN ONE OUT
		MOVLW		255						;ALL ROWS ARE INPUT 
		MOVWF		TRISB
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		BTFSC		ROW1					;CHECK ROW 1 FOR HIT
		GOTO		C1R2					;NOT 0 JUMP	
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1


C1R2	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C1R3					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C1R3	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C1R4					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C1R4 	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C1R5					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C1R5 	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C1R6					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C1R6 	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C1R7					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C1R7 	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C2R1					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7

;*********************************COLUMN 2**********************

C2R1    

		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11011111'				;GROUND COLUMN TWO
		MOVWF		PORTA
		MOVLW		255
		MOVWF		PORTB
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11011111'				;COLUMN TWO OUT
		MOVWF		TRISA
		MOVLW		255						;ROW 1 INPUT 
		MOVWF		TRISB
		BANKSEL		PORTA
		BTFSC		ROW1					;CHECK ROW 1 FOR 0
		GOTO		C2R2					;NOT 0 JUMP	
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1
		
C2R2	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C2R3					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C2R3	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C2R4					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C2R4	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C2R5					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C2R5	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C2R6					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C2R6	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C2R7					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C2R7	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C3R1					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7

;************************COLUMN 3*********************

C3R1    
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11101111'				;GROUND COLUMN THREE
		MOVWF		PORTA
		MOVLW		255
		MOVWF		PORTB
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11101111'				;COLUMN THREE OUT
		MOVWF		TRISA
		MOVLW		255						;ROW 1 INPUT 
		MOVWF		TRISB

		BANKSEL		PORTA
		BTFSC		ROW1					;CHECK ROW 1 FOR 0
		GOTO		C3R2					;NOT 0 JUMP	
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1
		

C3R2 	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C3R3					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C3R3 	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C3R4					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C3R4 	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C3R5					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C3R5 	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C3R6					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C3R6 	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C3R7					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C3R7 	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C4R1					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7

;**********************COLUMN 4 *********************

C4R1    
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11110111'				;GROUND COLUMN FOUR
		MOVWF		PORTA
		MOVLW		255
		MOVWF		PORTB
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11110111'				;COLUMN FOUR OUT
		MOVWF		TRISA
		MOVLW		255						;ROW 1 INPUT 
		MOVWF		TRISB

		BANKSEL		PORTA
 		BTFSC		ROW1					;CHECK ROW 1 FOR 0
		GOTO		C4R2					;NOT 0 JUMP	
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1
		

C4R2	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C4R3					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C4R3 	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C4R4					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C4R4 	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C4R5					;NOT 0 JUMP
		MOVLW		10						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C4R5 	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C4R6					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C4R6 	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C4R7					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C4R7 	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C5R1					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7	


;*********************COLUMN 5 ***********************

C5R1   
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11111011'				;GROUND COLUMN FIVE
		MOVWF		PORTA
		MOVLW		255
		MOVWF		PORTB
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11111011'				;COLUMN FIVE OUT
		MOVWF		TRISA
		MOVLW		255						;ROW 1 INPUT 
		MOVWF		TRISB

		BANKSEL		PORTA
		BTFSC		ROW1					;CHECK ROW 1 FOR 0
		GOTO		C5R2					;NOT 0 JUMP	
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1
		

C5R2	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C5R3					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C5R3 	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C5R4					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C5R4 	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C5R5					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C5R5 	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C5R6					;NOT 0 JUMP
		MOVLW		9						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C5R6 	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C5R7					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C5R7 	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C6R1					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7

;*********************COLUMN 6 ***************************

C6R1   
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11111101'				;GROUND COLUMN FIVE
		MOVWF		PORTA
		MOVLW		255
		MOVWF		PORTB
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11111101'				;COLUMN SIX OUT
		MOVWF		TRISA
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVLW		255						;ROW 1 INPUT 
		MOVWF		TRISB

		BANKSEL		PORTA
		BTFSC		ROW1					;CHECK ROW 1 FOR 0
		GOTO		C6R2					;NOT 0 JUMP	
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1
		

C6R2 	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C6R3					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C6R3 	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C6R4					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C6R4 	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C6R5					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C6R5 	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C6R6					;NOT 0 JUMP
		MOVLW		8						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C6R6 	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C6R7					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C6R7 	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C7R1					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7

;***********************COLUMN 7 *****************************

C7R1   
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11111110'				;GROUND COLUMN SEVEN
		MOVWF		PORTA
		MOVLW		255
		MOVWF		PORTB
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVLW		B'11111110'				;COLUMN SEVEN OUT
		MOVWF		TRISA					;LOAD
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVLW		255						;ROW 1 INPUT 
		MOVWF		TRISB					;LOAD

		BANKSEL		PORTA
		BTFSC		ROW1					;CHECK ROW 1 FOR 0
		GOTO		C7R2					;NOT 0 JUMP	
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A1						;GO TO A1
		

C7R2 	BTFSC		ROW2					;CHECK ROW 2 FOR 0
		GOTO		C7R3					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A2						;GO TO A2

C7R3 	BTFSC		ROW3					;CHECK ROW 2 FOR 0
		GOTO		C7R4					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A3						;GO TO A3

C7R4 	BTFSC		ROW4					;CHECK ROW 2 FOR 0
		GOTO		C7R5					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A4						;GO TO A4

C7R5 	BTFSC		ROW5					;CHECK ROW 2 FOR 0
		GOTO		C7R6					;NOT 0 JUMP
		MOVLW		7						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A5						;GO TO A5

C7R6 	BTFSC		ROW6					;CHECK ROW 2 FOR 0
		GOTO		C7R7					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A6						;GO TO A6

C7R7 	BTFSC		ROW7					;CHECK ROW 2 FOR 0
		GOTO		C1R1					;NOT 0 JUMP
		MOVLW		6						;LOAD 6 IN TO TARGET
		ADDWF		TARGET,1				;LOAD
		GOTO		A7						;GO TO A7


A1
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A
		MOVLW		B'11111101'			;ROW 1 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GO TO START


A2	
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A
		MOVLW		B'11111011'			;ROW 2 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GOTO START


A3		
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A
		MOVLW		B'11110111'			;ROW 3 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GOTO START

A4	
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A	
		MOVLW		B'11101111'			;ROW 4 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA				;MAKE SURE IN RIGHT BANK
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GOTO START
	
A5	
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A
		MOVLW		B'11011111'			;ROW 5 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT	
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA				;MAKE SURE IN RIGHT BANK
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GOTO START

A6	
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A
		MOVLW		B'10111111'			;ROW 6 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA				;MAKE SURE IN RIGHT BANK
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GOTO START

A7	
		BANKSEL		PORTB				;MAKE SURE IN RIGHT BANK
		COMF		PORTA,1				;COMPLEMENT PORT A
		MOVLW		B'01111111'			;ROW 7 GROUND
		MOVWF		PORTB				;LOAD
		MOVWF		TEMP				;LOAD
		BANKSEL		TRISB				;MAKE SURE IN RIGHT BANK
		CLRF		TRISB				;MAKE TRISB OUTPUT
		CLRF		TRISA				;MAKE TRISA OUTPUT
		BANKSEL		PORTA				;MAKE SURE IN RIGHT BANK
		CALL 		HIT					;CALL HIT
		CALL		INTIALIZING			;RE-INTIALIZE
		GOTO		START				;GOTO START

;**************DETERMINING WHAT SWITCH IS IN PLACE****************

HIT		BTFSC		SWITCH1					;CHECK POSITION OF JUMPER 1
		GOTO		HIT1					;SET GO TO HIT 1
		GOTO		HIT2					;CLEAR GO TO HIT 2
HIT1	BTFSC		SWITCH2					;CHECK POSITION OF JUMPER 2
		GOTO		HIT3					;J1 AND J2 SET GO TO HIT 3
		GOTO		SLOW_FIRE				;J1 SET AND J2 CLEAR GO SLOW_FIRE
HIT2	BTFSC		SWITCH2					;CHECK POSITION OF JUMPER 2
		GOTO		RAPID_FIRE				;J1 CLEAR AND J2 SET GO TO RAPID FIRE
		GOTO		TEST_PROGRAM			;CLEAR GO TO TEST PROGRAM
HIT3	GOTO		YOUR_PROGRAM			;J1 & J2 SET GO TO YOUR PROGRAM


TEST_PROGRAM
		MOVF		TARGET,0				;MOVE TARGET INTO MATH LOW
		MOVWF		MATH_LOW				;LOAD
		CALL		DECIMAL					;CONVERT DECIMAL TO BCD
		MOVLW		1						;LOAD 1 TIMER
		MOVWF		COUNT2					;LOAD 
		CALL		DISPLAY					;DISPLAY
		DECFSZ		COUNT1,1				;DELAY LOOP
		GOTO		$-2						;DELAY LOOP
		DECFSZ		COUNT2,1				;DELAY LOOP
		GOTO		$-4						;DELAY LOOP	
		CLRF		TARGET					;CLEAR TARGET COUNT
		RETURN								;RETURN TO CALL

SLOW_FIRE
		MOVF		TARGET,0				;MOVE TARGET INTO MATH LOW
		MOVWF		MATH_LOW				;LOAD
		CALL		DECIMAL					;CONVERT IDECIMAL TO BCD
		MOVLW		10						;LOAD 10 TIMER
		MOVWF		COUNT2					;LOAD 
		CALL		DISPLAY					;DISPLAY
		DECFSZ		COUNT1,1				;DELAY LOOP
		GOTO		$-2						;DELAY LOOP
		DECFSZ		COUNT2,1				;DELAY LOOP
		GOTO		$-4						;DELAY LOOP
		RETURN								;RETURN TO CALL

RAPID_FIRE

		INCF		COUNT,1					;INCREMENT COUNT


RF1		MOVLW		1						;CHECKING COUNT FOR 1
		SUBWF		COUNT,0					;CHECKING COUNT FOR 1
		BTFSS		3,2						;CHECKING COUNT FOR 1
		GOTO		RF2						;NOT 1 GO TO RF2
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVF		TRISB,0					;STORING TRISB INTO TRISB1
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB1					;LOAD
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA,0					;STORING TRISA INTO TRISA1
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA1					;LOAD
		MOVF		TEMP,0					;LOAD TEMP INTO FIRST ROW
		MOVWF		FIRST_ROW				;LOAD
		MOVF		PORTA,0					;LOAD PORT A IN FIRST COLUMN
		MOVWF		FIRST_COL				;LOAD
		MOVLW		2						;SETTING UP TIMING LOOP
		MOVWF		COUNT3					;TIMING LOOP
		DECFSZ		COUNT1,1				;TIMING LOOP
		GOTO		$-1						;TIMING LOOP
		DECFSZ		COUNT2,1				;TIMING LOOP
		GOTO		$-3						;TIMING LOOP
		DECFSZ		COUNT3,1				;TIMING LOOP
		GOTO		$-5						;TIMING LOOP
		CALL		INTIALIZING
		BCF			PORTC,6					;TURN ON 1S DIGIT
		BSF			PORTC,4
		BSF			PORTC,5
		MOVLW		220						;DISPLAY 1
		MOVWF		PORTD					;LOAD
		GOTO		A0						;RETURN

RF2		MOVLW		2						;CHECKING COUNT FOR 2 
		SUBWF		COUNT,0					;CHECKING COUNT FOR 2
		BTFSS		3,2						;CHECKING COUNT FOR 2
		GOTO		RF3						;NOT 2 GO TO RF3
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVF		TRISB,0					;STORE TRISB INTO TRISB2
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB2					;LOAD
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA,0					;STORE TRISA INTO TRISA2
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA2					;LOAD
		MOVF		TEMP,0					;LOAD TEMP INTO FIRST ROW
		MOVWF		SECOND_ROW				;STORE
		MOVF		PORTA,0					;LOAD PORT A IN FIRST COLUMN
		MOVWF		SECOND_COL				;STORE
		MOVLW		2						;SETTING UP TIMING LOOP
		MOVWF		COUNT3					;TIMING LOOP
		DECFSZ		COUNT1,1				;TIMING LOOP
		GOTO		$-1						;TIMING LOOP
		DECFSZ		COUNT2,1				;TIMING LOOP
		GOTO		$-3						;TIMING LOOP
		DECFSZ		COUNT3,1				;TIMING LOOP
		GOTO		$-5						;TIMING LOOP
		CALL		INTIALIZING
		BCF			PORTC,6					;TURN ON 1S DIGIT
		BSF			PORTC,4
		BSF			PORTC,5
		MOVLW		160						;DISPLAY 2
		MOVWF		PORTD					;LOAD
		GOTO		A0						;RETURN

RF3		MOVLW		3						;CHECK COUNT FOR 3
		SUBWF		COUNT,0					;CHECK COUNT FOR 3
		BTFSS		3,2						;CHECK COUNT FOR 3
		GOTO		RF4						;NOT 3 GO TO 4
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVF		TRISB,0					;STORE TRISB INTO TRISB3
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB3					;LOAD
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA,0					;STORE TRISA INTO TRISA3
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA3					;LOAD
		MOVF		TEMP,0					;LOAD TEMP INTO FIRST ROW
		MOVWF		THIRD_ROW				;STORE TEMP
		MOVF		PORTA,0					;LOAD PORT A IN FIRST COLUMN
		MOVWF		THIRD_COL				;STORE
		MOVLW		2						;SETTING UP TIMING LOOP
		MOVWF		COUNT3					;TIMING LOOP
		DECFSZ		COUNT1,1				;TIMING LOOP
		GOTO		$-1						;TIMING LOOP
		DECFSZ		COUNT2,1				;TIMING LOOP
		GOTO		$-3						;TIMING LOOP
		DECFSZ		COUNT3,1				;TIMING LOOP
		GOTO		$-5						;TIMING LOOP
		CALL		INTIALIZING
		BCF			PORTC,6					;TURN ON DIGIT 1
		BSF			PORTC,4
		BSF			PORTC,5
		MOVLW		192						;DISPLAY 3
		MOVWF		PORTD					;LOAD
		GOTO		A0						;RETURN

RF4		MOVLW		4						;CHECK COUNT FOR 4
		SUBWF		COUNT,0
		BTFSS		3,2
		GOTO		RF5						;NOT 4 GO TO 5
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVF		TRISB,0	
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB4
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA,0
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA4
		MOVF		TEMP,0					;LOAD TEMP INTO FIRST ROW
		MOVWF		FOURTH_ROW
		MOVF		PORTA,0					;LOAD PORT A IN FIRST COLUMN
		MOVWF		FOURTH_COL				;LOAD
		MOVLW		2						;LOADING 2
		MOVWF		COUNT3					;TIMING LOOP
		DECFSZ		COUNT1,1				;TIMING LOOP
		GOTO		$-1						;TIMING LOOP
		DECFSZ		COUNT2,1				;TIMING LOOP
		GOTO		$-3						;TIMING LOOP
		DECFSZ		COUNT3,1				;TIMING LOOP
		GOTO		$-5						;TIMING LOOP
		CALL		INTIALIZING
		BCF			PORTC,6					;PORTC 6 LOW
		BSF			PORTC,4
		BSF			PORTC,5
		MOVLW		84						;LOADING 84
		MOVWF		PORTD					;LOAD
		GOTO		A0						;RETURN

RF5		MOVLW		5						;CHECK COUNT FOR 5
		SUBWF		COUNT,0					
		BTFSS		3,2
		GOTO		RF6						;NOT FIVE GO TO 6
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVF		TRISB,0
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB5
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA,0
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA5
		MOVF		TEMP,0					;LOAD TEMP INTO FIRST ROW
		MOVWF		FIFTH_ROW
		MOVF		PORTA,0					;LOAD PORT A IN FIRST COLUMN
		MOVWF		FIFTH_COL				
		MOVLW		2
		MOVWF		COUNT3					;TIMING LOOP
		DECFSZ		COUNT1,1				;TIMING LOOP
		GOTO		$-1						;TIMING LOOP
		DECFSZ		COUNT2,1				;TIMING LOOP
		GOTO		$-3						;TIMING LOOP
		DECFSZ		COUNT3,1				;TIMING LOOP
		GOTO		$-5						;TIMING LOOP
		CALL		INTIALIZING
		BCF			PORTC,6
		BSF			PORTC,4
		BSF			PORTC,5
		MOVLW		66
		MOVWF		PORTD	
		GOTO		A0						;RETURN

RF6			
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVF		TRISB,0
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB6
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA,0
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA6
		MOVF		TEMP,0					;LOAD TEMP INTO FIRST ROW
		MOVWF		SIXTH_ROW
		MOVF		PORTA,0					;LOAD PORT A IN FIRST COLUMN
		MOVWF		SIXTH_COL				
		BCF			PORTC,6
		MOVLW		2
		MOVWF		PORTD					
		MOVLW		2
		MOVWF		COUNT3					;TIMING LOOP
		DECFSZ		COUNT1,1				;TIMING LOOP
		GOTO		$-1						;TIMING LOOP
		DECFSZ		COUNT2,1				;TIMING LOOP
		GOTO		$-3						;TIMING LOOP
		DECFSZ		COUNT3,1				;TIMING LOOP
		GOTO		$-5						;TIMING LOOP



RF7		MOVF		TARGET,0				;MOVE TARGET INTO MATH LOW
		MOVWF		MATH_LOW				;LOAD
		CALL		DECIMAL					;CONVERT DECIMAL TO BCD

RF8		MOVF		FIRST_ROW,0				;DISPLAY FIRST SHOT
		MOVWF		PORTB					;MOVE TEMP IN PORTB	
		MOVF		FIRST_COL,0				;MOVE FIRST COLUMN INTO PORTA
		MOVWF		PORTA					;LOAD
		MOVF		TRISB1,0				;MOVE TRISB1 INTO TRISB
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA1,0				;LOAD TRISA1 INTO TRISA
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA					;LOAD
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CALL		DISPLAY					;DISPLAY SCORE

RF9		MOVF		SECOND_ROW,W			;DISPLAY SECOND SHOT
		MOVWF		PORTB					;MOVE TEMP IN PORTB	
		MOVF		SECOND_COL,W			;MOVE SECOND COLUMN INTO PORT A
		MOVWF		PORTA					;LOAD
		MOVF		TRISB2,0				;MOVE TRISB2 INTO TRISB
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK 
		MOVWF		TRISB					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA2,0				;MOVE TRISA2 INTO TRISA
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA					;LOAD
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CALL		DISPLAY					;DISPLAY SCORE

RF10	MOVF		THIRD_ROW,W				;DISPLAY THIRD SHOT
		MOVWF		PORTB					;MOVE TEMP IN PORTB	
		MOVF		THIRD_COL,W				;MOVE THIRD COLUMN INTO PORTA
		MOVWF		PORTA					;LOAD
		MOVF		TRISB3,0				;MOVE TRISB3 INTO TRISB
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA3,0				;MOVE TRISA3 INTO TRISA
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA					;LOAD
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CALL		DISPLAY					;DISPLAY SCORE

RF11	MOVF		FOURTH_ROW,W			;DISPLAY FOURTH SHOT
		MOVWF		PORTB					;MOVE FOURTH ROW IN PORTB	
		MOVF		FOURTH_COL,W			;MOVE FOURTH COLUMN INTO PORT A
		MOVWF		PORTA					;LOAD
		MOVF		TRISB4,0				;MOVE TRISB3 INTO TRISB
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA4,0				;MOVE TRISA4 INTO TRISA
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA					;LOAD
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CALL		DISPLAY					;DISPLAY SCORE

RF12	MOVF		FIFTH_ROW,W				;MOV FIFTH ROW INTO PORT B
		MOVWF		PORTB					;LOAD
		MOVF		FIFTH_COL,W				;LOAD FIFTH COLUMN INTO PORT 
		MOVWF		PORTA					;LOAD
		MOVF		TRISB5,0				;LOAD TRISB5 INTO TRISA
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA5,0				;LOAD TRISA5 INTO TRISA
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA					;LOAD
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CALL		DISPLAY					;DISPLAY SCORE
	
RF13	MOVF		SIXTH_ROW,W				;MOVE SIXTH ROW INTO PORTB
		MOVWF		PORTB					;LOAD
		MOVF		SIXTH_COL,W				;MOVE SIXTH COLUMN INTO PORTA
		MOVWF		PORTA					;LOAD
		MOVF		TRISB6,0				;LOAD TRISB6 INTO TRISB
		BANKSEL		TRISB					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISB					;LOAD
		BANKSEL		PORTA					;MAKE SURE IN RIGHT BANK
		MOVF		TRISA6,0				;LOAD TRISA6 INTO TRISA
		BANKSEL		TRISA					;MAKE SURE IN RIGHT BANK
		MOVWF		TRISA					;LOAD
		BANKSEL		PORTB					;MAKE SURE IN RIGHT BANK
		CALL		DISPLAY					;DISPLAY SCORE
		GOTO		RF7						;PUT IN CONTINOUS LOOP
	
;*************************CONVERTING DECIMAL TO BCD******************************************;
;**********************CANNED PROGRAM**************************
DECIMAL

		SWAPF		MATH_HIGH,W
		ANDLW		0FH
		ADDLW		0F0H
		MOVWF		THOUSANDS
		ADDWF		THOUSANDS,F
		ADDLW		0E2H
		MOVWF		HUNDREDS
		ADDLW		32H
		MOVWF		ONES

		MOVF		MATH_HIGH,0
		ANDLW		0FH
		ADDWF		HUNDREDS,F
		ADDWF		HUNDREDS,F
		ADDWF		ONES,F
		ADDLW		0E9H
		MOVWF		TENS
		ADDWF		TENS,F
		ADDWF		TENS,F

		SWAPF		MATH_LOW,W
		ANDLW		0FH
		ADDWF		TENS,F
		ADDWF		ONES,F

		RLF			TENS,F
		RLF			ONES,F
		COMF		ONES,F
		RLF			ONES,F
			
		MOVF		MATH_LOW,W
		ANDLW		0FH
		ADDWF		ONES,F
		RLF			THOUSANDS,F
		
		MOVLW		07H
		MOVWF		TENK

		MOVLW		0AH
LB1		ADDWF		ONES,F
		DECF		TENS,F
		BTFSS		3,0
		GOTO		LB1
LB2		ADDWF		TENS,F
		DECF		HUNDREDS,F
		BTFSS		3,0
		GOTO		LB2

LB3		ADDWF		HUNDREDS,F
		DECF		THOUSANDS,F
		BTFSS		3,0
		GOTO		LB3

LB4		ADDWF		THOUSANDS,F
		DECF		TENK,F
		BTFSS		3,0
		GOTO		LB4				

		RETURN						;RETURN TO CALL

;***************************END OF DECIMAL TO BCD ****************************


YOUR_PROGRAM
		GOTO	$					;PUT YOUR PROGRAM HERE

DISPLAY
		MOVF		ONES,0			;MOVE ONES INTO W
		BSF			DIGIT_ONE		;TURN OFF DIGIT ONE
		BSF			DIGIT_THREE		;TURN OFF DIGIT THREE
		BSF			DIGIT_TWO		;TURN OFF DIGIT TWO
		MOVLW		01H				;LOAD INTO ADDR THE LOW ADDRESS OF LOOKUP TABLE LOOKUP TABLE ADDRESS 
		ADDWF		ONES,0			;ADD THE OFFSET TO THE LOW ADDRESS (ADDR)
		MOVLW		.5				;LOAD 8 INTO HIGH ADDRESS OF LOOKUP TABLE
		BTFSC		STATUS,C		;CHECK TO SEE IF THE OFFSET ADDED TO LOW LOOKUP TABLE WENT ABOVE 255
		ADDLW		1				;IF IT DID ADD 1 TO HIGH TABLE BYTE (PCLATH)
		MOVWF		PCLATH			;MOVE ONE INTO PCLATH REGISTER
		MOVF		ONES,0			;LOAD OFFSET INTO W
		CALL		PATTERN			;JUMP TO PATTERN
		CLRF		PCLATH			;RESET PCLATH
		MOVWF		PORTD			;MOVE PATTERN INTO PORTC
		BCF			DIGIT_THREE		;TURN ON DIGIT THREE
		CALL		DELAY1			;CALL THIS LABEL. THIS DELAY ALLOWS FOR BETTER DISPLAYING

		MOVF		TENS,0			;MOVE TENS INTO W
		BSF			DIGIT_ONE		;TURN OFF DIGIT ONE
		BSF			DIGIT_THREE		;TURN OFF DIGIT THREE
		BSF			DIGIT_TWO		;TURN OFF DIGIT TWO
		MOVLW		01H				;LOAD INTO ADDR THE LOW ADDRESS OF LOOKUP TABLE LOOKUP TABLE ADDRESS 
		ADDWF		TENS,0			;ADD THE OFFSET TO THE LOE ADDRESS (ADDR)
		MOVLW		.5				;LOAD 8 INTO HIGH ADDRESS OF LOOKUP TABLE
		BTFSC		STATUS,C		;CHECK TO SEE IF THE OFFSET ADDED TO LOW LOOKUP TABLE WENT ABOVE 255
		ADDLW		1				;IF IT DID ADD 1 TO HIGH TABLE BYTE (PCLATH)
		MOVWF		PCLATH			;MOVE ONE INTO PCLATH REGISTER
		MOVF		TENS,0			;LOAD OFFSET INTO W
		CALL 		PATTERN			;CALL PATTERN AND RETURN
		CLRF		PCLATH			;RESET PCLATH
		MOVWF		PORTD			;MOVE WHAT WAS IN PATTERN TO PORT B
		BCF			DIGIT_TWO		;TURN ON DIGIT TWO
		CALL		DELAY1			;CALL THIS LABEL. THIS DELAY ALLOWS FOR BETTER DISPLAYING		
	
		MOVF		HUNDREDS,0		;MOVE HUNDREDS INTO W
		BSF			DIGIT_ONE		;TURN OFF DIGIT ONE
		BSF			DIGIT_TWO		;TURN OFF DIGIT TWO
		BSF			DIGIT_THREE		;TURN OFF DIGIT THREE
		MOVLW		01H				;LOAD INTO ADDR THE LOW ADDRESS OF LOOKUP TABLE LOOKUP TABLE ADDRESS 
		ADDWF		HUNDREDS,0		;ADD THE OFFSET TO THE LOW ADDRESS (ADDR)
		MOVLW		.5				;LOAD 8 INTO HIGH ADDRESS OF LOOKUP TABLE
		BTFSC		STATUS,C		;CHECK TO SEE IF THE OFFSET ADDED TO LOW LOOKUP TABLE WENT ABOVE 255
		ADDLW		1				;IF IT DID ADD 1 TO HIGH TABLE BYTE (PCLATH)
		MOVWF		PCLATH			;MOVE ONE INTO PCLATH REGISTER
		MOVF		HUNDREDS,0		;LOAD OFFSET INTO W
		CALL 		PATTERN			;CALL PATTERN AND RETURN
		CLRF		PCLATH			;RESET PCLATH
		MOVWF		PORTD			;MOVE WHAT WAS IN PATTERN TO PORT C
		BCF			DIGIT_ONE		;TURN ON DIGIT ONE
		CALL		DELAY1			;CALL THIS LABEL. THIS DELAY ALLOWS FOR BETTER DISPLAYING	
		BSF			DIGIT_ONE		;TURN OFF DIGIT ONE
		RETURN						;RETURN TO CALL

DELAY1	DECFSZ	COUNT4,1			;DELAY FOR DISPLAY
		GOTO	$-1					;DELAY
		RETURN 						;RETURN TO CALL


;*******************PATTERN LOOK UP TABLE**************************
		ORG	500H
PATTERN							;LABEL 

		ADDWF	PCL,1			;ADD W TO PROGRAM COUNTER AND LOOK UP DATA
		RETLW	8				;0
		RETLW	220				;1
		RETLW	160				;2
		RETLW	192				;3
		RETLW	84				;4
		RETLW	66				;5
		RETLW	2				;6
		RETLW	216				;7
		RETLW	0				;8
		RETLW	64				;9

    END                       ; directive 'end of program'